Index: cpp/frams/_demos/simil_test.cpp
===================================================================
--- cpp/frams/_demos/simil_test.cpp	(revision 601)
+++ cpp/frams/_demos/simil_test.cpp	(revision 605)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2015  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2016  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -17,24 +17,5 @@
 /** Computes a matrix of distances between all genotypes in the specified
     .gen file, using the matching and measure weights as specified in the
-    command line.
-
-    Command line parameters: [-names] <genotypesFile> <w_dP> <w_dDEG> <w_dNEU> <w_dGEO>
-
-    Parameters:
-      <genotypesFile> name of a file with genotypes
-      <w_dP> weight of the difference in the number of parts
-      <w_dDEG> weight of the difference in degrees of matched parts
-      <w_dNEU> weight of the difference in neurons of matched parts
-      <w_dGEO> weight of the distance between matched parts
-
-    Switches:
-      -names specifies that the number and names of genotypes are to be printed to output
-        before the distance matrix; by default the number and names are not printed
-
-    Outputs a distance matrix in the format:
-    <row_1> (columns in a row are separated by TABs)
-    ...
-    <row_n>
- */
+    command line. */
 int main(int argc, char *argv[])
 {
@@ -49,22 +30,21 @@
     if (argc < 7)
     {
-        // too few parameters
         printf("Too few parameters!\n");
-        printf("Command line: [-names] <genotypesFile> <w_dP> <w_dDEG> <w_dNEU> <w_dGEO> <isZfixed>\n\n");
+        printf("Command line: [-names] <genotypesFile> <w_dP> <w_dDEG> <w_dNEU> <w_dGEO> <fixZaxis?>\n\n");
         printf("Parameters:\n");
-        printf(" <genotypesFile> name of a file with genotypes\n");
-        printf(" <w_dP> weight of the difference in the number of parts\n");
-        printf(" <w_dDEG> weight of the difference in degrees of matched parts\n");
-        printf(" <w_dNEU> weight of the difference in neurons of matched parts\n");
-        printf(" <w_dGEO> weight of the distance of matched parts\n\n");
-	printf(" <isZFixed> should z cooridante be fixed during the alignment\n");
+        printf("  <genotypesFile> name of a file with genotypes\n");
+        printf("  <w_dP> weight of the difference in the number of parts\n");
+        printf("  <w_dDEG> weight of the difference in degrees of matched parts\n");
+        printf("  <w_dNEU> weight of the difference in neurons of matched parts\n");
+        printf("  <w_dGEO> weight of the distance of matched parts\n");
+        printf("  <fixZaxis?> should the 'z' (vertical) coordinate be fixed during the alignment? (0 or 1)\n\n");
         printf("Switches:\n");
-        printf(" -names specifies that the number and names of genotypes are to be printed to output\n");
-        printf("   before the distance matrix; by default the number and names are not printed\n\n");
+        printf("  -names specifies that the number and names of genotypes are to be printed to output\n");
+        printf("  before the distance matrix; by default the number and names are not printed\n\n");
 
         printf("Outputs a symmetric distance matrix in the format:\n");
-        printf(" <row_1> (columns in a row are separated by TABs)\n");
-        printf(" ...\n");
-        printf(" <row_n>\n");
+        printf("  <row_1> (columns in a row are separated by TABs)\n");
+        printf("  ...\n");
+        printf("  <row_n>\n");
 
         return -1;
@@ -130,8 +110,8 @@
         return -1;
     }
-    else if (M.zFixed != 0 && M.zFixed !=1)
-    {
-	printf("<isZFixed>=%d. <isZFixed> should be equal to 0 or 1\n", M.zFixed);
-	return -1;
+    else if (M.zFixed != 0 && M.zFixed != 1)
+    {
+    	printf("<isZFixed>=%d. <isZFixed> should be equal to 0 or 1\n", M.zFixed);
+    	return -1;
     }
     
@@ -194,6 +174,5 @@
     if (bPrintNames)
     {
-        // if "-names" switch was given,
-        // print the number of genotypes and their names
+        // if "-names" switch was given, print the number of genotypes and their names
         printf("%li\n", pvGenos.size());
 		for (unsigned int iGen = 0; iGen < pvNames.size(); iGen++)