Index: mds-and-trees/tree-genealogy.py
===================================================================
--- mds-and-trees/tree-genealogy.py	(revision 614)
+++ mds-and-trees/tree-genealogy.py	(revision 615)
@@ -1,3 +1,4 @@
 # Draws a genealogical tree (generates a SVG file) based on parent-child relationship information.
+# Supports files generated by Framsticks experiments.
 
 import json
@@ -38,5 +39,5 @@
             int(hex, 16)
         except:
-            print("Wrong characters in the color's hex #" + hex + "! Assuming black.")
+            print("Invalid characters in the color's hex #" + hex + "! Assuming black.")
             return default_style
         red = 100*int(hex[0:2], 16)/255
@@ -48,5 +49,5 @@
         return ' stroke="rgb(' +str(red)+ '%,' +str(green)+ '%,' +str(blue)+ '%)" stroke-opacity="' +str(opacity)+ '" '
     else:
-        print("Wrong number of digits in the color's hex #" + hex + "! Assuming black.")
+        print("Invalid number of digits in the color's hex #" + hex + "! Assuming black.")
         return default_style
 
@@ -113,5 +114,5 @@
                             nodes[creature["ID"]][creature["FromIDs"][i]] = inherited
                     else:
-                        print("Doubled entry for " + creature["ID"])
+                        print("Duplicated entry for " + creature["ID"])
                         quit()
 
@@ -294,4 +295,5 @@
         svg_add_dot( (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height), dot_style)
         #svg_add_text( str(depth[c]), (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height), "end")
+
 def draw_children():
     global visited
@@ -329,4 +331,5 @@
                 (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height), line_style)
         #svg_add_dot( (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height), svg_spine_dot_style)
+
 def draw_spine():
     global visited
@@ -353,6 +356,6 @@
             svg_add_line( (w_margin+w_no_margs*(positions[node][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[node][1]/max_height),
                 (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height), line_style)
-            #svg_add_dot( (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height),
-            #             svg_spine_dot_style)
+            #svg_add_dot( (w_margin+w_no_margs*(positions[c][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[c][1]/max_height), svg_spine_dot_style)
+
 def draw_skeleton():
     global visited
@@ -361,6 +364,5 @@
 
     draw_skeleton_reccurent(firstnode)
-    #svg_add_dot( (w_margin+w_no_margs*(positions[firstnode][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[firstnode][1]/max_height),
-    #             svg_spine_dot_style)
+    #svg_add_dot( (w_margin+w_no_margs*(positions[firstnode][0]-min_width)/(max_width-min_width), h_margin+h_no_margs*positions[firstnode][1]/max_height), svg_spine_dot_style)
 
 # ------------------------------------
@@ -368,5 +370,5 @@
 def draw_scale(filename ,type):
 
-    svg_add_text( "Generated from " + filename.split("\\")[-1], (5, 15), "start")
+    svg_add_text("Generated from " + filename.split("\\")[-1], (5, 15), "start")
 
     svg_add_line( (w*0.7, h_margin), (w, h_margin), svg_scale_line_style)
@@ -422,7 +424,7 @@
         svg_mutation_line_style, svg_crossover_line_style
 
-    parser = argparse.ArgumentParser(description='Draws a genealogical tree (generates a SVG file) based on parent-child relationship information from a text file. Supports with files generated by Framsticks experiments.')
-    parser.add_argument('-i', '--in', dest='input', required=True, help='input file with stuctured evolutionary data')
-    parser.add_argument('-o', '--out', dest='output', required=True, help='output file for the evolutionary tree')
+    parser = argparse.ArgumentParser(description='Draws a genealogical tree (generates a SVG file) based on parent-child relationship information from a text file. Supports files generated by Framsticks experiments.')
+    parser.add_argument('-i', '--in', dest='input', required=True, help='input file name with stuctured evolutionary data')
+    parser.add_argument('-o', '--out', dest='output', required=True, help='output file name for the evolutionary tree (SVG format)')
     draw_tree_parser = parser.add_mutually_exclusive_group(required=False)
     draw_tree_parser.add_argument('--draw-tree', dest='draw_tree', action='store_true', help='whether drawing the full tree should be skipped')
@@ -507,3 +509,2 @@
 
 main()
-