Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 641)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 663)
@@ -36,4 +36,5 @@
 		<element name="smooth" type="integer" min="0" max="1" default="1"/>
 		<element name="neurons" type="integer" min="0" max="1" default="1"/>
+		<element name="dust" type="integer" min="0" max="1" default="1"/>
 	</type>
 	<type name="show" context="show file">
@@ -340,4 +341,7 @@
 			</arguments>
 		</element>
+		<element name="outdated_neuro_classes" type="untyped" flags="35">
+			<description><![CDATA[Names of the neuron classes that have been modified after this creature was built]]></description>
+		</element>
 		<element name="selfmask" type="integer" min="0" max="2147483647" default="0" flags="32">
 			<description><![CDATA[Creature's selfmask is set according to the Creature's Population.selfmask. See Population.selfmask for detailed information about collision handling.]]></description>
@@ -467,5 +471,5 @@
 		</element>
 		<element name="size" type="integer" flags="1"/>
-		<element name="clear" function="true" type="void" flags="1"><arguments/></element>
+		<element name="clear" function="true" type="void"><arguments/></element>
 	</type>
 	<type name="CreatureSnapshot" context="Global context">
@@ -850,6 +854,7 @@
 		<element name="randomLikeGeno" function="true" type="Genotype" flags="34">
 			<description><![CDATA[Returns a random genotype index similar to the target genotype. Unrated genotypes (with instances=0) are treated as if they had instances=1 and average fitness. Read about details:
-http://www.framsticks.com/node/795
-http://www.framsticks.com/node/890]]></description>
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016]]></description>
 			<arguments>
 				<argument name="minimum similarity" type="float"/>
@@ -860,5 +865,6 @@
 			<description><![CDATA[Returns a random genotype similar to the target genotype, fitness-proportional. Unrated genotypes (with instances=0) are treated as if they had instances=1 and average fitness. Read about details:
 http://www.framsticks.com/node/795
-http://www.framsticks.com/node/890]]></description>
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016]]></description>
 			<arguments>
 				<argument name="minimum similarity" type="float"/>
@@ -1674,6 +1680,7 @@
 		<element name="simi" type="float" flags="3">
 			<description><![CDATA[Read about details:
-http://www.framsticks.com/node/795
-http://www.framsticks.com/node/890]]></description>
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016]]></description>
 		</element>
 		<element name="energ0" type="float" deprecated="true" flags="8227"/>
@@ -1725,5 +1732,5 @@
 -1 = validity is not known. This is a transient state. The value of "is_valid" will never be -1 when read. It is safe to treat is_valid as boolean in statements like "if (g.is_valid) ...". Setting "is_valid=-1" will make it 0 or 1 again. This third state (-1) is only needed for loading Genotype objects from files where the "is_valid" field might not be present.]]></description>
 		</element>
-		<element name="getNormalized" function="true" type="float" flags="35">
+		<element name="getNormalized" function="true" type="float" flags="32">
 			<arguments>
 				<argument name="property name or index" type="untyped"/>
@@ -1736,5 +1743,5 @@
 			<description><![CDATA[Unique identifier]]></description>
 		</element>
-		<element name="getModel" function="true" type="Model" flags="35"><arguments/></element>
+		<element name="getModel" function="true" type="Model" flags="32"><arguments/></element>
 		<element name="splitInstances" function="true" type="void" flags="32"><arguments/></element>
 		<element name="newFromString" function="true" type="Genotype" flags="32">
@@ -1956,5 +1963,5 @@
 		<element name="pi2" type="float" flags="1"/>
 		<element name="pi4" type="float" flags="1"/>
-		<element name="random" function="true" type="integer" flags="1">
+		<element name="random" function="true" type="integer">
 			<description><![CDATA[0..num-1]]></description>
 			<arguments>
@@ -1963,5 +1970,5 @@
 		</element>
 		<element name="rnd01" type="float" flags="1"/>
-		<element name="rndUni" function="true" type="float" flags="1">
+		<element name="rndUni" function="true" type="float">
 			<description><![CDATA[[begin..end)]]></description>
 			<arguments>
@@ -1971,5 +1978,5 @@
 		</element>
 		<element name="rndGaussStd" type="float" flags="1"/>
-		<element name="rndGauss" function="true" type="float" flags="1">
+		<element name="rndGauss" function="true" type="float">
 			<description><![CDATA[rndGaussStd is rndGauss(0,1)]]></description>
 			<arguments>
@@ -1978,5 +1985,5 @@
 			</arguments>
 		</element>
-		<element name="rndCustom" function="true" type="float" flags="1">
+		<element name="rndCustom" function="true" type="float">
 			<description><![CDATA[the parameter describes the desired random distribution, being a sum of uniform distributions, eg. rndCustom([-10,-1, -1,1, 1,10]) defines 3 uniform distribution intervals [-1,10) [-1,1), [1,10)]]></description>
 			<arguments>
@@ -2196,6 +2203,7 @@
 	<type name="ModelSimilarity" context="Global context">
 <description><![CDATA[Evaluates morphological dissimilarity. More information:
-http://www.framsticks.com/node/795
-http://www.framsticks.com/node/890]]></description>
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016]]></description>
 		<element name="simil_parts" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[Differing number of parts is also handled by the 'part degree' similarity component.]]></description>
@@ -2222,5 +2230,5 @@
 	</type>
 	<type name="ModelSymmetry" context="Global context">
-<description><![CDATA[Calculates bilateral symmetry. Details are described in http://www.framsticks.com/node/808]]></description>
+<description><![CDATA[Calculates bilateral symmetry. Details are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
 		<element name="calculateSymmetry" function="true" type="float" flags="32">
 			<description><![CDATA[Returns bilateral symmetry (0.0 .. 1.0) for a given Model using default precision parameters (symPosSteps,symAlphaSteps,symBetaSteps). Returns the symmetry plane, too (sets symResultA,B,C,D).
@@ -2445,15 +2453,15 @@
 		<element name="Vstyle" type="string" max="-1" default="neuro"/>
 		<element name="getInputCount" type="integer" flags="3"/>
-		<element name="getInputNeuroDef" function="true" type="NeuroDef" flags="3">
+		<element name="getInputNeuroDef" function="true" type="NeuroDef">
 			<arguments>
 				<argument type="integer"/>
 			</arguments>
 		</element>
-		<element name="getInputNeuroIndex" function="true" type="integer" flags="3">
+		<element name="getInputNeuroIndex" function="true" type="integer">
 			<arguments>
 				<argument type="integer"/>
 			</arguments>
 		</element>
-		<element name="getInputWeight" function="true" type="float" flags="3">
+		<element name="getInputWeight" function="true" type="float">
 			<arguments>
 				<argument type="integer"/>
@@ -2758,5 +2766,5 @@
 		</element>
 		<element name="size" type="integer" flags="1"/>
-		<element name="clear" function="true" type="void" flags="1"><arguments/></element>
+		<element name="clear" function="true" type="void"><arguments/></element>
 	</type>
 	<type name="ODE" context="Global context">
@@ -3242,4 +3250,5 @@
 			<description><![CDATA[How many frames are to be generated?]]></description>
 		</element>
+		<element name="povex_dust" type="integer" min="0" max="1" default="1"/>
 		<element name="povex_enable" function="true" flags="8"/>
 		<element name="povex_disable" function="true" flags="8"/>
@@ -3555,5 +3564,5 @@
 		<element name="changedPropertyId" type="string" flags="35"/>
 		<element name="wrldtyp" type="integer" min="0" max="2" default="0"/>
-		<element name="wrldsiz" type="float" min="10" max="1000" default="20.0">
+		<element name="wrldsiz" type="float" min="10" max="10000" default="20.0">
 			<description><![CDATA[Side length of the world]]></description>
 		</element>
@@ -4718,4 +4727,7 @@
 	</type>
 	<type name="SlaveSimulators" context="Global context">
+<description><![CDATA[This is a vector of slave Simulator objects. More details in:
+http://www.framsticks.com/bib/Komosinski-and-Ulatowski-2013r
+http://www.framsticks.com/bib/Komosinski-and-Ulatowski-2016]]></description>
 		<element name="size" type="integer" min="0" max="50">
 			<description><![CDATA[Changing this value will create/remove slave simulator objects as needed.]]></description>
@@ -5103,4 +5115,7 @@
 			</arguments>
 		</element>
+		<element name="SERIALIZATION_PREFIX" type="string" flags="1">
+			<description><![CDATA[String prefix used in the Framsticks file format to indicate object fields that contain serialized objects.]]></description>
+		</element>
 	</type>
 	<type name="UserScripts" context="Global context">
@@ -5145,4 +5160,10 @@
 			</arguments>
 		</element>
+		<element name="insert" function="true" type="void" flags="256">
+			<arguments>
+				<argument name="position" type="integer"/>
+				<argument name="value" type="untyped"/>
+			</arguments>
+		</element>
 		<element name="add" function="true" type="void" flags="256">
 			<arguments>
@@ -5208,5 +5229,5 @@
 <description><![CDATA[Environment properties.]]></description>
 		<element name="wrldtyp" type="integer" min="0" max="2" default="0"/>
-		<element name="wrldsiz" type="float" min="10" max="1000" default="20.0">
+		<element name="wrldsiz" type="float" min="10" max="10000" default="20.0">
 			<description><![CDATA[Side length of the world]]></description>
 		</element>
@@ -5336,5 +5357,5 @@
 		</element>
 		<element name="size" type="integer" flags="1"/>
-		<element name="clear" function="true" type="void" flags="1"><arguments/></element>
+		<element name="clear" function="true" type="void"><arguments/></element>
 	</type>
 	<type name="XYZ" context="Global context">
@@ -5442,15 +5463,15 @@
 		<element name="Vstyle" type="string" max="-1" default="neuro"/>
 		<element name="getInputCount" type="integer" flags="3"/>
-		<element name="getInputNeuroDef" function="true" type="NeuroDef" flags="3">
+		<element name="getInputNeuroDef" function="true" type="NeuroDef">
 			<arguments>
 				<argument type="integer"/>
 			</arguments>
 		</element>
-		<element name="getInputNeuroIndex" function="true" type="integer" flags="3">
+		<element name="getInputNeuroIndex" function="true" type="integer">
 			<arguments>
 				<argument type="integer"/>
 			</arguments>
 		</element>
-		<element name="getInputWeight" function="true" type="float" flags="3">
+		<element name="getInputWeight" function="true" type="float">
 			<arguments>
 				<argument type="integer"/>
@@ -5589,6 +5610,7 @@
 		<element name="simi" type="float" flags="3">
 			<description><![CDATA[Read about details:
-http://www.framsticks.com/node/795
-http://www.framsticks.com/node/890]]></description>
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016]]></description>
 		</element>
 		<element name="energ0" type="float" deprecated="true" flags="8227"/>
@@ -5640,5 +5662,5 @@
 -1 = validity is not known. This is a transient state. The value of "is_valid" will never be -1 when read. It is safe to treat is_valid as boolean in statements like "if (g.is_valid) ...". Setting "is_valid=-1" will make it 0 or 1 again. This third state (-1) is only needed for loading Genotype objects from files where the "is_valid" field might not be present.]]></description>
 		</element>
-		<element name="getNormalized" function="true" type="float" flags="35">
+		<element name="getNormalized" function="true" type="float" flags="32">
 			<arguments>
 				<argument name="property name or index" type="untyped"/>
@@ -5651,5 +5673,5 @@
 			<description><![CDATA[Unique identifier]]></description>
 		</element>
-		<element name="getModel" function="true" type="Model" flags="35"><arguments/></element>
+		<element name="getModel" function="true" type="Model" flags="32"><arguments/></element>
 		<element name="splitInstances" function="true" type="void" flags="32"><arguments/></element>
 		<element name="newFromString" function="true" type="Genotype" flags="32">
@@ -5926,4 +5948,7 @@
 				<argument name="index" type="integer"/>
 			</arguments>
+		</element>
+		<element name="outdated_neuro_classes" type="untyped" flags="35">
+			<description><![CDATA[Names of the neuron classes that have been modified after this creature was built]]></description>
 		</element>
 		<element name="selfmask" type="integer" min="0" max="2147483647" default="0" flags="32">
@@ -6222,15 +6247,15 @@
 		<element name="Vstyle" type="string" max="-1" default="neuro"/>
 		<element name="getInputCount" type="integer" flags="3"/>
-		<element name="getInputNeuroDef" function="true" type="NeuroDef" flags="3">
+		<element name="getInputNeuroDef" function="true" type="NeuroDef">
 			<arguments>
 				<argument type="integer"/>
 			</arguments>
 		</element>
-		<element name="getInputNeuroIndex" function="true" type="integer" flags="3">
+		<element name="getInputNeuroIndex" function="true" type="integer">
 			<arguments>
 				<argument type="integer"/>
 			</arguments>
 		</element>
-		<element name="getInputWeight" function="true" type="float" flags="3">
+		<element name="getInputWeight" function="true" type="float">
 			<arguments>
 				<argument type="integer"/>
@@ -6266,7 +6291,8 @@
 	</type>
 	<type name="Scene" context="Visual style definition">
-<description><![CDATA[Additional properties to be used in the current view, currently only the background settings]]></description>
-		<element name="backcolor" type="integer"/>
+<description><![CDATA[Additional properties to be used in the current view]]></description>
+		<element name="backcolor" type="integer" min="0" max="16777215" default="16777215"/>
 		<element name="worldtexture" type="string"/>
+		<element name="dustcolor" type="integer" min="0" max="16777215" default="15126952"/>
 	</type>
 	<type name="VertexBuilder" context="Visual style definition">
@@ -6350,5 +6376,5 @@
 			<description><![CDATA[Displays a guess of the symmetry plane (may take a long time to compue for complex bodies).
 Use scripting and the ModelSymmetry class to compute symmetry accurately.
-Details of the symmetry estimation procedure are described in http://www.framsticks.com/node/808]]></description>
+Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
 		</element>
 	</type>
@@ -6387,4 +6413,5 @@
 		<element name="smooth" type="integer" min="0" max="1" default="1"/>
 		<element name="neurons" type="integer" min="0" max="1" default="1"/>
+		<element name="dust" type="integer" min="0" max="1" default="1"/>
 		<element name="clear" function="true" flags="34"/>
 		<element name="add" function="true" flags="34"/>
@@ -6427,5 +6454,5 @@
 			<description><![CDATA[Displays a guess of the symmetry plane (may take a long time to compue for complex bodies).
 Use scripting and the ModelSymmetry class to compute symmetry accurately.
-Details of the symmetry estimation procedure are described in http://www.framsticks.com/node/808]]></description>
+Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
 		</element>
 	</type>
@@ -6433,5 +6460,5 @@
 <description><![CDATA[Environment properties.]]></description>
 		<element name="wrldtyp" type="integer" min="0" max="2" default="0"/>
-		<element name="wrldsiz" type="float" min="10" max="1000" default="20.0">
+		<element name="wrldsiz" type="float" min="10" max="10000" default="20.0">
 			<description><![CDATA[Side length of the world]]></description>
 		</element>
@@ -6767,9 +6794,10 @@
 Bits 2-16 are not implemented in the old Framsticks Theater application.]]></description>
 		</element>
-		<element name="world_visibility" type="integer" min="0" max="7" default="7">
+		<element name="world_visibility" type="integer" min="0" max="15" default="15">
 			<description><![CDATA[Bit field:
 1 - background/panorama
 2 - environment
 4 - creatures
+8 - dust (particles)
 Not implemented in the old Framsticks Theater application.]]></description>
 		</element>
@@ -6788,5 +6816,8 @@
 Not implemented in the old Framsticks Theater application.]]></description>
 		</element>
-		<element name="bgcolor" type="integer">
+		<element name="bgcolor" type="integer" min="0" max="16777215" default="16777215">
+			<description><![CDATA[Not implemented in the old Framsticks Theater application.]]></description>
+		</element>
+		<element name="dustcolor" type="integer" min="0" max="16777215" default="15126952">
 			<description><![CDATA[Not implemented in the old Framsticks Theater application.]]></description>
 		</element>
@@ -6876,4 +6907,9 @@
 		</element>
 		<element name="newScroll" function="true" type="GUIElement">
+			<arguments>
+				<argument name="name" type="string"/>
+			</arguments>
+		</element>
+		<element name="newSpinner" function="true" type="GUIElement">
 			<arguments>
 				<argument name="name" type="string"/>
@@ -7256,4 +7292,5 @@
 		<element name="addScreenshot" function="true" type="void"><arguments/></element>
 		<element name="removeImage" function="true" type="void"><arguments/></element>
+		<element name="supported" type="integer" min="0" max="1" flags="1"/>
 		<element name="select" function="true" type="void">
 			<arguments>
@@ -7396,4 +7433,5 @@
 		<element name="smooth" type="integer" min="0" max="1" default="1"/>
 		<element name="neurons" type="integer" min="0" max="1" default="1"/>
+		<element name="dust" type="integer" min="0" max="1" default="1"/>
 		<element name="clear" function="true" flags="34"/>
 		<element name="add" function="true" flags="34"/>
@@ -7436,5 +7474,5 @@
 			<description><![CDATA[Displays a guess of the symmetry plane (may take a long time to compue for complex bodies).
 Use scripting and the ModelSymmetry class to compute symmetry accurately.
-Details of the symmetry estimation procedure are described in http://www.framsticks.com/node/808]]></description>
+Details of the symmetry estimation procedure are described in http://www.framsticks.com/bib/Komosinski-and-Jaskowski-2008]]></description>
 		</element>
 	</type>