Index: /experiments/frams/evolve-speed-vs-gravity/go-evol-water.cmd
===================================================================
--- /experiments/frams/evolve-speed-vs-gravity/go-evol-water.cmd	(revision 702)
+++ /experiments/frams/evolve-speed-vs-gravity/go-evol-water.cmd	(revision 703)
@@ -5,5 +5,5 @@
 for %%G in (1.0) do (
 
-frams "ex standard" "Simulator.creatwarnfail=1;" "World.wrldwat=20;" "ExpProperties.stagnation=30000;" "Populations[0].nnsim=Populations[0].enableperf=1;" "ExpProperties.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity_args(%%G,100);" -q >exp-evol-speed\testwater_%%G_%%R.out
+frams "expdef standard" "Simulator.creatwarnfail=1;" "World.wrldwat=20;" "ExpProperties.stagnation=30000;" "Populations[0].nnsim=Populations[0].enableperf=1;" "ExpProperties.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity_args(%%G,100);" -q >exp-evol-speed\testwater_%%G_%%R.out
 
 )
Index: /experiments/frams/evolve-speed-vs-gravity/go-evol.cmd
===================================================================
--- /experiments/frams/evolve-speed-vs-gravity/go-evol.cmd	(revision 702)
+++ /experiments/frams/evolve-speed-vs-gravity/go-evol.cmd	(revision 703)
@@ -5,5 +5,5 @@
 for %%G in (0.2,0.4,0.6,0.8,1.0, 1.2,1.4,1.6,1.8,2.0) do (
 
-frams "ex standard" "Simulator.creatwarnfail=1;" "ExpProperties.stagnation=30000;" "ExpProperties.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity_args(%%G,100);" -q >exp-evol-speed\test_%%G_%%R.out
+frams "expdef standard" "Simulator.creatwarnfail=1;" "ExpProperties.stagnation=30000;" "ExpProperties.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity_args(%%G,100);" -q >exp-evol-speed\test_%%G_%%R.out
 
 )
Index: /experiments/frams/logic/run-abduction.cmd
===================================================================
--- /experiments/frams/logic/run-abduction.cmd	(revision 702)
+++ /experiments/frams/logic/run-abduction.cmd	(revision 703)
@@ -7,7 +7,7 @@
 
 rem The abduction problem consting of an abductive goal being a simple conjuction and two formulas forming a database:
-frams "ex logic_abduction" "ExpProperties.params=\"K_q_s;C_p_q C_r_s;abdOut1.txt\"; Simulator.init();" "go" "qu"
+frams "expdef logic_abduction" "ExpProperties.params=\"K_q_s;C_p_q C_r_s;abdOut1.txt\"; Simulator.init();" "go" "qu"
 
 rem The abduction problem consting of an abductive goal being a propositional variable and two formulas forming a database:
-frams "ex logic_abduction" "ExpProperties.params=\"q;C_K_p_r_q C_C_N_r_q_p;abdOut2.txt\"; Simulator.init();" "go" "qu"
+frams "expdef logic_abduction" "ExpProperties.params=\"q;C_K_p_r_q C_C_N_r_q_p;abdOut2.txt\"; Simulator.init();" "go" "qu"
 
Index: /experiments/frams/multi-threading/test-mt.cmd
===================================================================
--- /experiments/frams/multi-threading/test-mt.cmd	(revision 702)
+++ /experiments/frams/multi-threading/test-mt.cmd	(revision 703)
@@ -12,13 +12,13 @@
 
 rem no mutation, no crossover, only cloning - so that the same genotype is always evaluated. Useful to measure "raw" efficiency of parallel computation
-rem frams "ex standard-mt" "ExpProperties.threads=%%T;" "ExpProperties.p_mut=0;" "ExpProperties.p_xov=0;" "ExpProperties.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(0,6,10);" -q >exp-evol-speed-nochange\test_%%T_%%C.out
+rem frams "expdef standard-mt" "ExpProperties.threads=%%T;" "ExpProperties.p_mut=0;" "ExpProperties.p_xov=0;" "ExpProperties.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(0,6,10);" -q >exp-evol-speed-nochange\test_%%T_%%C.out
 
 
 rem same as above but with a bigger genotype, so that the time spent on script processing is relatively shorter, and more time is used for pure simulation 
-rem frams "ex standard-mt" "ExpProperties.threads=%%T;" "ExpProperties.p_mut=0;" "ExpProperties.p_xov=0;" "ExpProperties.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(6,6,10);" -q >exp-evol-speed-nochange-biggeno\test_%%T_%%C.out
+rem frams "expdef standard-mt" "ExpProperties.threads=%%T;" "ExpProperties.p_mut=0;" "ExpProperties.p_xov=0;" "ExpProperties.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(6,6,10);" -q >exp-evol-speed-nochange-biggeno\test_%%T_%%C.out
 
 
 rem keep threads running and only cloning
-frams "ex standard-mt" "ExpProperties.threads=%%T;" "ExpProperties.capacity=%%C;" "ExpProperties.p_mut=0;" "ExpProperties.p_xov=0;" "ExpProperties.keep_threads_running=1;" "UserScripts.script_Multithreading_efficiency_test_args(3,50,10);" -q >exp-evol-speed-nochange-keeprunning\test_%%T_%%C.out
+frams "expdef standard-mt" "ExpProperties.threads=%%T;" "ExpProperties.capacity=%%C;" "ExpProperties.p_mut=0;" "ExpProperties.p_xov=0;" "ExpProperties.keep_threads_running=1;" "UserScripts.script_Multithreading_efficiency_test_args(3,50,10);" -q >exp-evol-speed-nochange-keeprunning\test_%%T_%%C.out
 
 